<script setup lang="ts">
import { computed, type PropType } from "vue";
import type { Colors } from "@/types/PropTypes";

const props = defineProps({
  colorClass: {
    type: String as PropType<Colors>,
    required: false,
    default: "success",
  },
  toastId: { type: String, required: true },
});

const emit = defineEmits<{
  (e: "hide.bs.toast"): void;
  (e: "hidden.bs.toast"): void;
  (e: "show.bs.toast"): void;
  (e: "shown.bs.toast"): void;
}>();

const colorClassName = computed<string>(() => {
  return `text-bg-${props.colorClass}`;
});
</script>

<template>
  <Teleport to="#global-toast-container">
    <div
      :id="props.toastId"
      role="alert"
      aria-live="assertive"
      aria-atomic="true"
      class="toast align-items-center border-0"
      :class="colorClassName"
      data-bs-autohide="true"
      v-on="{
        'hidden.bs.toast': emit('hidden.bs.toast'),
        'hide.bs.toast': emit('hide.bs.toast'),
        'show.bs.toast': emit('show.bs.toast'),
        'shown.bs.toast': emit('shown.bs.toast'),
      }"
    >
      <div class="toast-body">
        <div class="d-flex justify-content-between fs-6">
          <div class="flex-fill">
            <slot></slot>
          </div>
          <button
            type="button"
            class="btn-close btn-close-white me-2"
            data-bs-dismiss="toast"
            aria-label="Close"
          ></button>
        </div>
        <div v-if="$slots.body" class="mt-2 pt-2 border-top">
          <slot name="body"></slot>
        </div>
      </div>
    </div>
  </Teleport>
</template>

<style scoped></style>
